/*
 * Copyright (C) 2017 Laboratoire ThéMA - UMR 6049 - CNRS / Université de Franche-Comté
 * http://thema.univ-fcomte.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


package org.thema.fractalopolis.access;

import java.awt.Frame;
import java.util.Map;
import javax.swing.JOptionPane;
import org.thema.common.collection.HashMap2D;
import org.thema.common.param.ParamEditorDialog;
import org.thema.fractalopolis.Project;
import org.thema.fractalopolis.ifs.Fractal.Scale;

/**
 *
 * @author gvuidel
 */
public class AccessibilitiesDialog extends javax.swing.JDialog {

    private Accessibilities access;
    /**
     * Creates new form AccessibilitiesDialog
     */
    public AccessibilitiesDialog(java.awt.Frame parent, Accessibilities access) {
        super(parent, true);
        initComponents();
        this.access = access;
        table.setModel(access.getTableModel());
        setLocationRelativeTo(parent);
        distanceButton.setEnabled(access.getScale() == Scale.MICRO);
        v2CheckBox.setSelected(access.getVersion() == 2);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        table = new javax.swing.JTable();
        paramButton = new javax.swing.JButton();
        closeButton = new javax.swing.JButton();
        levelsButton = new javax.swing.JButton();
        distanceButton = new javax.swing.JButton();
        v2CheckBox = new javax.swing.JCheckBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Parameters used to assess the interest of each square to be developed");

        jScrollPane1.setViewportView(table);

        paramButton.setText("Eval. rules");
        paramButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                paramButtonActionPerformed(evt);
            }
        });

        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        levelsButton.setText("Frequency");
        levelsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                levelsButtonActionPerformed(evt);
            }
        });

        distanceButton.setText("Distance");
        distanceButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                distanceButtonActionPerformed(evt);
            }
        });

        v2CheckBox.setText("V2");
        v2CheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                v2CheckBoxActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 291, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(distanceButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(paramButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(levelsButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(closeButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addComponent(v2CheckBox))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(paramButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(levelsButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(distanceButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(v2CheckBox)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 31, Short.MAX_VALUE)
                        .addComponent(closeButton))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeButtonActionPerformed

    private void paramButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_paramButtonActionPerformed
        int ind = table.getSelectedRow();
        if(ind < 0) {
            return;
        }
        Accessibility a = access.getAccessibilities().get(ind);
        if(a.getParams().isEmpty()) {
            return;
        }
        ParamEditorDialog<Map<String, Object>> dlg = new ParamEditorDialog<>(this, a.getParams());
        dlg.setVisible(true);
        if(dlg.isOk) {
            a.setParams(dlg.getValue());
        }
        
    }//GEN-LAST:event_paramButtonActionPerformed

    private void levelsButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_levelsButtonActionPerformed
        access.getAggregator().setTable(ParamEditorDialog.editParam(this, "Frequency", HashMap2D.class, access.getAggregator().getTable(), null));
    }//GEN-LAST:event_levelsButtonActionPerformed

    private void distanceButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_distanceButtonActionPerformed
        DistanceDialog dlg = new DistanceDialog((Frame)this.getParent(), access);
        dlg.setVisible(true);
        if(dlg.getReturnStatus() == DistanceDialog.RET_CANCEL) {
            return;
        }
        access.setDistType(dlg.distType);
    }//GEN-LAST:event_distanceButtonActionPerformed

    private void v2CheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_v2CheckBoxActionPerformed
        int res = JOptionPane.showConfirmDialog(this, "All accessibility parameters will be reset.\nDo you want to continue ?", "Accessibility version", JOptionPane.YES_NO_OPTION);
        if(res != JOptionPane.YES_OPTION) {
            v2CheckBox.setSelected(!v2CheckBox.isSelected());
            return;
        }
        access.setVersion(v2CheckBox.isSelected()? 2 : 0, Project.project);
        table.setModel(access.getTableModel());
    }//GEN-LAST:event_v2CheckBoxActionPerformed

   
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton closeButton;
    private javax.swing.JButton distanceButton;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton levelsButton;
    private javax.swing.JButton paramButton;
    private javax.swing.JTable table;
    private javax.swing.JCheckBox v2CheckBox;
    // End of variables declaration//GEN-END:variables
}
